
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <zip.h>
#include <QtGui> 
#include <QApplication>
#include <QWidget>
#include "tnoc.h"

#ifdef fr

#define ERRORTITLE tr("Erreur")
#define READERROR tr("Fichier Introuvable")
#define WRITEERROR tr("Impossible d'enregistrer le fichier\nAvez-vous les autorisations en écriture dans le répertoire spécifié ?")
#define NOOPTIONERROR tr("Vous n'avez pas choisi d'option !")
#define CHOOSEFILE "Choisissez un fichier d'OS à épurer - [ *.tno/*.tnc/*.tco/*.tcc/*.tmo/*.tmc/*.tlo ]"
#define FILELIST "\
Tous les OS TI-Nspire (*.tno *.tnc *.tco *.tcc *.tmo *.tmc *.tlo)\n \
OS TI-Nspire (*.tno)\n \
OS TI-Nspire CAS (*.tnc)\n \
OS TI-Nspire CX (*.tco)\n \
OS TI-Nspire CX CAS (*.tcc)\n \
OS TI-Nspire CM (*.tmo)\n \
OS TI-Nspire CM CAS (*.tmc)\n \
OS TI-Nspire LabStation (*.tlo)\n \
Tous les fichiers (*.*)"
#define ABOUTTITLE tr("A propos de TNOC")
#define ABOUT tr("\
\n TNOC a été crée par des membres\nde la communauté francophone TI-Planet.\n\n\
http://tiplanet.org/\n\n\
  Xavier Andréani \t -- \t Idée d'origine \n\
\t\t\t    + Recherches\n\
  Sam101 \t\t -- \t Code initial\n\
  Levak \t\t -- \t Intégration de l'interface graphique Qt4\n\
  Codeslicer & Levak \t -- \t Compilations\n\n\
Merci à Critor2000 & Lionel Debroux\npour leurs précieux conseils et leur soutien !\n\
\n\n\
\t               -- 2011 --")
#define SUCCESSTITLE tr("Fichier converti !")
#define SUCCESS "Le fichier a correctement été converti à l'emplacement \n"

#else

#define ERRORTITLE tr("Error")
#define READERROR tr("File Not Found !")
#define WRITEERROR tr("Unable to save file\nDo you have write permission in the specified directory?")
#define NOOPTIONERROR tr("You didn't choose any option !")
#define CHOOSEFILE "Choose a file - [ *.tno/*.tnc/*.tco/*.tcc/*.tmo/*.tmc/*.tlo ]"
#define FILELIST "\
All TI-Nspire OS(*.tno *.tnc *.tco *.tcc *.tmo *.tmc *.tlo)\n \
TI-Nspire OS (*.tno)\n \
TI-Nspire CAS OS (*.tnc)\n \
TI-Nspire CX OS (*.tco)\n \
TI-Nspire CX CAS OS (*.tcc)\n \
TI-Nspire CM OS (*.tmo)\n \
TI-Nspire CM CAS OS (*.tmc)\n \
TI-Nspire LabStation (*.tlo)\n \
All files (*.*)"
#define ABOUTTITLE tr("A propos de TNOC")
#define ABOUT tr("\
\n TNOC has been developped by members of the French community TI-Planet.\n\n\
http://tiplanet.org/\n\n\
  Xavier Andréani \t -- \t Original Idea \n\
\t\t\t    + Research\n\
  Sam101 \t\t -- \t Initial Code\n\
  Levak \t\t -- \t GUI Qt4 integration\n\
  Codeslicer & Levak \t -- \t Compilations\n\n\
Thanks to Critor2000 & Lionel Debroux\nfor their great advice and support !\n\
\n\n\
\t               -- 2011 --")
#define SUCCESSTITLE tr("File converted !")
#define SUCCESS "The file has been successfully converted here : \n"

#endif


int convert_file(char *mode, char *input, char *output)
{
	char buffer = ' ';
	char size_buffer[25];
	int size_buffer_size;
	int i, j, input_size, output_size, error;
	char *header;
	FILE *input_file, *output_file, *temp_file ;
	struct zip *temp_file_zip;

	/*Open input/output file*/
	input_file = fopen(input,"rb");
	if (input_file == NULL)
	{
		printf("INPUT_FILE does not exist. \n%s\n", input);
		return -2;
	}

	output_file = fopen(output,"wb");
	if (output_file == NULL)
	{
		fclose(input_file);
		printf("OUTPUT_FILE opening failed.\n%s\n", output);
		return -1;
	}
   
	temp_file = fopen("temp.zip","wb");
   
/* Read input file size */
	fseek(input_file,0,SEEK_END);
	input_size = ftell(input_file);
	fseek(input_file,0,SEEK_SET);
/*Read input file header.*/
	i = -1;
	header = (char*) malloc(sizeof(char) * 1000);
	memset(header,0,1000);
	do
	{
		i++;
		fread(header + i,sizeof(char),1,input_file);
	}
	while ((header[i] != 'P'));
	header[i] = '\0';
/* write the header to output_file*/
	fwrite(header,sizeof(char),strlen(header),output_file);   
   
/* We write the temporary zip file */
	fseek(input_file,-1,SEEK_CUR);
	do
	{
		fread(&buffer,sizeof(char),1,input_file);
		fwrite(&buffer,sizeof(char),1,temp_file);
	}
	while (!feof(input_file));
	fclose(temp_file);
/* We open the temporary zip file and delete boot2.img and boot2.cer*/
	temp_file_zip = zip_open("temp.zip",0,&error);

	if ((mode[0] == 'b') || (mode[1] == 'b') )
	{
		zip_delete(temp_file_zip,zip_name_locate(temp_file_zip,"boot2.cer",0));
		zip_delete(temp_file_zip,zip_name_locate(temp_file_zip,"boot2.img",0));
	}
	if ((mode[0] == 's') || (mode[1] == 's') )
	{
		zip_delete(temp_file_zip,zip_name_locate(temp_file_zip,"samples.zip",0));
	}
	zip_close(temp_file_zip);
 /* We open the zip file and write it to output_file*/
	temp_file = fopen("temp.zip","rb");
	do
	{
		fread(&buffer,sizeof(char),1,temp_file);
		fwrite(&buffer,sizeof(char),1,output_file);
	} while (!feof(temp_file));
	fclose(temp_file);
/* We get output_file size */
	fseek(output_file,0,SEEK_END);
	output_size = ftell(output_file);
	fseek(output_file,0,SEEK_SET);
/* We write new file size */
	sprintf(size_buffer,"%d",input_size);
	
	i = strstr(header,size_buffer) - header;
	sprintf(size_buffer,"%d",output_size);
	size_buffer_size = strlen(size_buffer);

// Log10 difference
	int diff = (int)log10(input_size) - size_buffer_size + 1;
	memset(header + i, ' ', diff);
	memcpy(header + i + diff, size_buffer, size_buffer_size);
	
	fwrite(header,sizeof(char),strlen(header),output_file);      
/* We close file streams */

        (header);
	fclose(input_file);
	fclose(output_file);
	remove("temp.zip");
	return 0;
}

tnoc::tnoc(QWidget*)
{
	setupUi( this);
	connect( Open_button, SIGNAL( clicked() ), this, SLOT( getPath() ) ); 
	connect( Ok_button, SIGNAL( clicked() ), this, SLOT( convert() ) );
        connect( About_button, SIGNAL( clicked() ), this, SLOT( About() ) );
}
 
 
void tnoc::getPath()
{
    QString path;
    
    path = QFileDialog::getOpenFileName(this, CHOOSEFILE, QString::null, FILELIST);
 
    LineEdit->setText( path );
}

void tnoc::About()
{
    QTextCodec::setCodecForCStrings(QTextCodec::codecForName("UTF-8"));
    QTextCodec::setCodecForTr(QTextCodec::codecForName("UTF-8"));
    QTextCodec::setCodecForLocale(QTextCodec::codecForName("UTF-8"));

    QMessageBox::information(this, ABOUTTITLE, ABOUT);
}
 
void tnoc::convert()
{
	QTextCodec::setCodecForCStrings(QTextCodec::codecForName("UTF-8"));
	QTextCodec::setCodecForTr(QTextCodec::codecForName("UTF-8"));
	QTextCodec::setCodecForLocale(QTextCodec::codecForName("UTF-8"));
	
	bool boot2_state = boot2->checkState() == Qt::Checked;
	bool sample_state = samples->checkState() == Qt::Checked;
		
	char* option = (char*) malloc(3);
	option[0] = '\0';
	if(boot2_state)
		strcat(option, "b");
	if(sample_state)
		strcat(option, "s");
		
	if(boot2_state || sample_state)
	{
		if(LineEdit->text().length() > 0)
		{
			int pathLength = LineEdit->text().length();
			char* path = (char*) malloc(pathLength + 1);
			strcpy(path, (char*) LineEdit->text().toStdString().c_str());

			char* path_2 = (char*) malloc(pathLength + 5);
			strcpy(path_2, path);

			// remove the extension if any
			int pos = strrchr(path, '.') - path;
			if(pos >= 0)
				memmove(path_2 + pos + strlen(option) + 1, path_2 + pos, pathLength - pos + 1);
			else
				pos = pathLength;
				
			path_2[pos] = '_';
			memcpy(path_2 + pos + 1, option, strlen(option));

			int error = convert_file(option, (char*)path, (char*)path_2);

			if (error == 0)
			{
				char* popupMess = (char*) malloc(strlen(SUCCESS) + pathLength + 5);
				strcpy(popupMess, SUCCESS);
				strcat(popupMess, path_2);

				QMessageBox::information(this, SUCCESSTITLE, tr(popupMess));

				free(popupMess);
			}
			else if(error == -2)
				QMessageBox::critical(this, ERRORTITLE, READERROR);
			else if (error == -1)
				QMessageBox::critical(this, ERRORTITLE, WRITEERROR);
			else
				printf("The impossible occurred %s Line %i", __FILE__, __LINE__);

			free(path);
			free(path_2);
		}
		else
		{
			QMessageBox::warning(this, ERRORTITLE, READERROR);
		}
	}	
	else
	{
		QMessageBox::warning(this, ERRORTITLE, NOOPTIONERROR);
	}
	free(option);
}
